/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.productratestrategy.controller;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.guosen.bussinessRateStrategy.entity.BussinessRateStrategy;
import org.springblade.modules.guosen.productratestrategy.dto.ProductRateDTO;
import org.springblade.modules.guosen.productratestrategy.dto.ProductRateStrategyDTO;
import org.springblade.modules.guosen.productratestrategy.vo.SimpleProductRateStrategyVO;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.guosen.productratestrategy.entity.ProductRateStrategy;
import org.springblade.modules.guosen.productratestrategy.vo.ProductRateStrategyVO;
import org.springblade.modules.guosen.productratestrategy.wrapper.ProductRateStrategyWrapper;
import org.springblade.modules.guosen.productratestrategy.service.IProductRateStrategyService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-10-21
 */
@RestController
@AllArgsConstructor
@RequestMapping("cyzh-product-rate-strategy/productratestrategy")
@Api(value = "", tags = "接口")
public class ProductRateStrategyController extends BladeController {

	private final IProductRateStrategyService productRateStrategyService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入productRateStrategy")
	public R<ProductRateStrategyVO> detail(ProductRateStrategy productRateStrategy) {
		ProductRateStrategy detail = productRateStrategyService.getOne(Condition.getQueryWrapper(productRateStrategy));
		if(detail != null){
			List<ProductRateDTO> rateList = JSONArray.parseArray(detail.getProductRateJson(), ProductRateDTO.class);
			ProductRateStrategyVO vo = new ProductRateStrategyVO();
			vo.setId(detail.getId());
			vo.setRateList(rateList);
			vo.setName(detail.getName());
			return R.data(vo);
		}else{
			return R.data(null);
		}
	}

	/**
	 * 分页 
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入productRateStrategy")
	public R<IPage<ProductRateStrategyVO>> list(ProductRateStrategy productRateStrategy, Query query) {
		IPage<ProductRateStrategy> pages = productRateStrategyService.page(Condition.getPage(query), Condition.getQueryWrapper(productRateStrategy));
		return R.data(ProductRateStrategyWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页 
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入productRateStrategy")
	public R<IPage<ProductRateStrategyVO>> page(ProductRateStrategyVO productRateStrategy, Query query) {
		IPage<ProductRateStrategyVO> pages = productRateStrategyService.selectProductRateStrategyPage(Condition.getPage(query), productRateStrategy);
		return R.data(pages);
	}

	/**
	 * 新增 
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入productRateStrategy")
	public R save(@Valid @RequestBody ProductRateStrategy productRateStrategy) {
		return R.status(productRateStrategyService.save(productRateStrategy));
	}

	/**
	 * 修改 
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入productRateStrategy")
	public R update(@Valid @RequestBody ProductRateStrategy productRateStrategy) {
		return R.status(productRateStrategyService.updateById(productRateStrategy));
	}

	/**
	 * 新增或修改 
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入productRateStrategy")
	public R submit(@Valid @RequestBody ProductRateStrategyDTO productRateStrategyDTO) {
		return this.productRateStrategyService.createStrategy(productRateStrategyDTO);
	}

	
	/**
	 * 删除 
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(productRateStrategyService.deleteLogic(Func.toLongList(ids)));
	}

	/**
	 * 删除
	 */
	@GetMapping("/listRateStrategy")
	@ApiOperationSupport(order = 8)
	@ApiOperation(value = "产品策略列表", notes = "传入ids")
	public R<List<SimpleProductRateStrategyVO>> listRateStrategy() {
		List<ProductRateStrategy> list = this.productRateStrategyService.list();
		List<SimpleProductRateStrategyVO>  voList = list.stream().map(item -> {
			SimpleProductRateStrategyVO vo = new SimpleProductRateStrategyVO();
			vo.setId(item.getId());
			vo.setName(item.getName());
			return vo;
		}).collect(Collectors.toList());
		if(voList != null && voList.size() > 0){
			return R.data(voList);
		}else{
			return R.data(new ArrayList<>());
		}
	}

	
}
